<?php
	if(phpversion()>="5.1.0"){
		date_default_timezone_set('Asia/Tokyo');
	}
class PXBASE{
  /*
    pxbase ver 0.6.6 2020/04/12
    Copyright (c) 2002-2020 Hideya Tanaka
  */
  
  var $ELEMENT_TYPE = 1;
  var $ATTR_TYPE = 2;
  var $TEXT_TYPE = 3;
  var $DTD_TYPE = 4;
  var $PI_TYPE = 5;
  var $COMMENT_TYPE = 6;
  var $XML_TYPE = 7;
  var $NAME_TYPE = 8;
  
  var $table = "";            //ơ֥̾
  var $dbname = "";           //ǡ١̾
  
  var $p_encode = "EUC-JP";   //  ϤXMLδ
  var $i_encode = "UTF8";   //  DBδ
  var $text = "";             //  ƥȥХåե  

  function __construct($con,$table){
    if($con == "")
      die("<br>顼<br>PXBASE:³꥽Ǥ");
    if($table == "")
      die("<br>顼<br>PXBASE:ơ֥̾Ǥ");
    $this->con = $con;
    $this->table = $table;
  }
  
  function do_query($sql,$func){
    $result = pg_query($this->con,$sql);
    if(! $result) {
      $sql2 = "rollback";
      $result2 = pg_query($this->con,$sql2);
      if(! $result2) {
        print("<br>顼<br>$func:do_query: ${sql2}μ¹Ԥ˼Ԥޤ<br>");
      }
      die("<br>顼<br>$func:do_query: ${sql}μ¹Ԥ˼Ԥޤ<br>");
    }
    return $result;
  }
  function begin() {
    $sql = "begin";
    $this->do_query($sql,"begin");
  }
  function commit() {
    $sql = "commit";
    $this->do_query($sql,"commit");
  }
  function lock() {
    $sql = "lock table $this->table in share row exclusive mode";
    $this->do_query($sql,"lock");
  }
  function free_result($result) {
    return pg_free_result($result);
  }
  function num_rows($result){
    return pg_numrows($result);
  }
  function result($result,$row,$field){
    $text = pg_fetch_result($result,$row,$field);
    $text = mb_convert_encoding($text,"$this->p_encode","$this->i_encode");
//print "field=$field,text=$text<br>";
    return $text;
  }
  
  function make_table($flg){
    if($flg == 1){
      $sql = "select id from $this->table";
      @$result = pg_query($this->con,$sql);
      if($result){
        $sql = "drop table $this->table";
        $this->do_query($sql,"make_table");
      }
    }
    $sql = "create table $this->table (
            id integer NOT NULL,
            type smallint,
            name text,
            value text,
            parent integer,
            pos smallint,
            ns text,
            PRIMARY KEY(id))";
    //        print $sql;
    $this->do_query($sql,"make_table");
  }
  
  function get_root(){
    return(0);
  }
  function get_doc_root(){
    $sql = "select id from $this->table where parent=0 and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"get_doc_root");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_doc_root:ɥȥ롼Ȥͭޤ");
    $id = $this->result ($result, 0, 0);
    $this->free_result($result);
    return($id);
  }
  function is_exist($id){
    $sql = "select id from $this->table where id=$id";
    $result = $this->do_query($sql,"");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num ==0)
      return false;
    else
      return true;
  }
  function is_element($id){
    $sql = "select value from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"is_element");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num != 0){
      return true;
    }else{
      return false;
    }
  }
  function is_text($id){
    $sql = "select value from $this->table where id=$id and type=$this->TEXT_TYPE";
    $result = $this->do_query($sql,"is_text");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num != 0){
      return true;
    }else{
      return false;
    }
  }
  function is_attrib($id){
    $sql = "select value from $this->table where id=$id and type=$this->ATTR_TYPE";
    $result = $this->do_query($sql,"is_attrib");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num != 0){
      return true;
    }else{
      return false;
    }
  }
  function is_comment($id){
    $sql = "select value from $this->table where id=$id and type=$this->COMMENT_TYPE";
    $result = $this->do_query($sql,"is_comment");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num != 0){
      return true;
    }else{
      return false;
    }
  }
  function is_dtd($id){
    $sql = "select value from $this->table where id=$id and type=$this->DTD_TYPE";
    $result = $this->do_query($sql,"is_dtd");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num != 0){
      return true;
    }else{
      return false;
    }
  }
  function is_pi($id){
    $sql = "select value from $this->table where id=$id and type=$this->PI_TYPE";
    $result = $this->do_query($sql,"is_pi");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num != 0){
      return true;
    }else{
      return false;
    }
  }
  function is_xml($id){
    $sql = "select value from $this->table where id=$id and type=$this->XML_TYPE";
    $result = $this->do_query($sql,"is_xml");
    $num = $this->num_rows($result);
    $this->free_result($result);
    if($num != 0){
      return true;
    }else{
      return false;
    }
  }
  function get_elements($id,$text){
    if($text == ""){
      die("<br>顼<br>get_elements:ѥǤid=$id path=$text");
    }
    $node_array = array();
    $node_name = array();
    $node_name = explode("/",$text);
    $node_level = count($node_name);
    if($node_level > 1){
      for($i=0;$i<$node_level-1;$i++){
        if($node_name[$i] == "") continue;
        $name = $node_name[$i];
        $name = addslashes($name);
        $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
        $sql = "select id from $this->table where parent=$id and name='$name' and type=$this->ELEMENT_TYPE order by pos";
        $result = $this->do_query($sql,"get_elements");
        $num = $this->num_rows($result);
        if($num == 0){
          $name = mb_convert_encoding($name,"$this->p_encode","$this->i_encode");
          die("<br>顼<br>get_elements:Ρֹ椫ѥ۾Ǥname = $name id=$id path=$text");
        }
        $id = $this->result ($result, 0, 0);
        $this->free_result($result);
      }
    }                            
    $name = $node_name[$node_level-1];
    $name = addslashes($name);
    $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$name' and type=$this->ELEMENT_TYPE order by pos";
    $result = $this->do_query($sql,"get_elements");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $node_array[$i] = $this->result ($result, $i, 0);
    }
    $this->free_result($result);
    return $node_array;
  }
  function get_elements_ns($id,$text,$ns){
    if($text == ""){
      die("<br>顼<br>get_elements_ns:ѥǤid=$id path=$text ns=$ns");
    }
    $node_array = array();
    $node_name = array();
    $node_name = explode("/",$text);
    $node_level = count($node_name);
    if($node_level > 1){
      for($i=0;$i<$node_level-1;$i++){
        if($node_name[$i] == "") continue;
        $name = $node_name[$i];
        $name = addslashes($name);
        $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
        $sql = "select id from $this->table where parent=$id and name='$name' and type=$this->ELEMENT_TYPE order by pos";
        $result = $this->do_query($sql,"get_elements_ns");
        $num = $this->num_rows($result);
        if($num == 0){
          $name = mb_convert_encoding($name,"$this->p_encode","$this->i_encode");
          die("<br>顼<br>get_elements_ns:Ρֹ椫ѥ۾Ǥname = $name id=$id path=$text");
        }
        $id = $this->result ($result, 0, 0);
        $this->free_result($result);
      }
    }                            
    $name = $node_name[$node_level-1];
    $name = addslashes($name);
    $ns = addslashes($ns);
    $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$name' and ns='$ns' and type=$this->ELEMENT_TYPE order by pos";
    $result = $this->do_query($sql,"get_elements_ns");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $node_array[$i] = $this->result ($result, $i, 0);
    }
    $this->free_result($result);
    return $node_array;
  }
  function get_first_element($id,$text){
    if($text == ""){
      die("<br>顼<br>get_first_element:ѥǤid=$id path=$text");
    }
    $node_name = array();
    $node_name = explode("/",$text);
    $node_level = count($node_name);
    for($i=0;$i<$node_level;$i++){
      if($node_name[$i] == "") continue;
      $name = $node_name[$i];
      $name = addslashes($name);
      $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
      $sql = "select id from $this->table where parent=$id and name='$name' and type=$this->ELEMENT_TYPE order by pos";
      $result = $this->do_query($sql,"get_first_element");
      $num = $this->num_rows($result);
      if($num == 0)
        die("<br>顼<br>get_first_element:Ρֹ椫ѥ۾Ǥid=$id path=$text");
      $id = $this->result ($result, 0, 0);
      $this->free_result($result);
    }
    return $id;
  }
  function get_first_element_ns($id,$text,$ns){
    if($text == ""){
      die("<br>顼<br>get_first_element_ns:ѥǤid=$id path=$text ns=$ns");
    }
    $node_array = array();
    $node_name = array();
    $node_name = explode("/",$text);
    $node_level = count($node_name);
    if($node_level > 1){
      for($i=0;$i<$node_level-1;$i++){
        if($node_name[$i] == "") continue;
        $name = $node_name[$i];
        $name = addslashes($name);
        $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
        $sql = "select id from $this->table where parent=$id and name='$name' and type=$this->ELEMENT_TYPE order by pos";
        $result = $this->do_query($sql,"get_first_elements_ns");
        $num = $this->num_rows($result);
        if($num == 0){
          $name = mb_convert_encoding($name,"$this->p_encode","$this->i_encode");
          die("<br>顼<br>get_first_elements_ns:Ρֹ椫ѥ۾Ǥname = $name id=$id path=$text ns=$ns");
        }
        $id = $this->result ($result, 0, 0);
        $this->free_result($result);
      }
    }                            
    $name = $node_name[$node_level-1];
    $name = addslashes($name);
    $ns = addslashes($ns);
    $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$name' and ns='$ns' and type=$this->ELEMENT_TYPE order by pos";
    $result = $this->do_query($sql,"get_first_elements_ns");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_first_element_ns:Ρֹ椫ѥ͡ॹڡ۾Ǥid=$id path=$text ns=$ns");
    $id = $this->result ($result, 0, 0);
    $this->free_result($result);
    return $id;
  }
  function get_child_elements($id,$child_name){
    if($child_name == ""){
      die("<br>顼<br>get_child_elements:ѥǤid=$id child_name=$child_name");
    }
    $node_array = array();
    $child_name = addslashes($child_name);
    $child_name = mb_convert_encoding($child_name,"$this->i_encode","$this->p_encode");
    if($child_name == "*"){
      $sql = "select id from $this->table where parent=$id and type=$this->ELEMENT_TYPE order by pos";
    }else{
      $sql = "select id from $this->table where parent=$id and name='$child_name' and type=$this->ELEMENT_TYPE order by pos";
    }
    $result = $this->do_query($sql,"get_child_elements");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $node_array[$i] = $this->result ($result, $i, 0);
    }
    $this->free_result($result);
    return $node_array;
  }
  function get_child_elements_ns($id,$child_name,$ns){
    if($child_name == ""){
      die("<br>顼<br>get_child_elements_ns:ѥǤid=$id child_name=$child_name ns=$ns");
    }
    $node_array = array();
    $child_name = addslashes($child_name);
    $ns = addslashes($ns);
    $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    if($child_name == "*"){
      $sql = "select id from $this->table where parent=$id and ns='$ns' and type=$this->ELEMENT_TYPE order by pos";
    }else{
      $sql = "select id from $this->table where parent=$id and name='$child_name' and ns='$ns' and type=$this->ELEMENT_TYPE order by pos";
    }
    $result = $this->do_query($sql,"get_child_elements_ns");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $node_array[$i] = $this->result ($result, $i, 0);
    }
    $this->free_result($result);
    return $node_array;
  }
  function get_comments($parent){
    $node_array = array();
    $sql = "select id from $this->table where parent=$parent and type=$this->COMMENT_TYPE order by pos";
    $result = $this->do_query($sql,"get_comments");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $node_array[$i] = $this->result ($result, $i, 0);
    }
    $this->free_result($result);
    return $node_array;
  }
  function get_parent($id){
    $sql = "select parent from $this->table where id=$id";
    $result = $this->do_query($sql,"get_parent");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_parent:Ρֹ椬۾Ǥid=$id");
    $parent = $this->result ($result, 0, 0);
    $this->free_result($result);
    return $parent;
  }
  function get_text($id){
    $sql = "select value from $this->table where id=$id and type=$this->TEXT_TYPE";
    $result = $this->do_query($sql,"get_text");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_text:Ρֹ椬۾Ǥid=$id");
    $value = stripslashes($this->result ($result, 0, 0));
    $this->free_result($result);
    return $value;
  }
  function get_text_nodes($id){
    $sql = "select id from $this->table where parent=$id and type=$this->TEXT_TYPE order by pos";
    $result = $this->do_query($sql,"get_text_nodes");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_text_nodes:Ρֹ椬۾狼ƥȤͭޤid=$id");
    $node_array = array();
    for($i=0;$i<$num;$i++){
      $node_array[$i] = $this->result ($result, $i, 0);
    }
    $this->free_result($result);
    return $node_array;
  }
  function get_value($id){
    $sql = "select value from $this->table where parent=$id and type=$this->TEXT_TYPE order by pos";
    $result = $this->do_query($sql,"get_value");
    $num = $this->num_rows($result);
//            if($num == 0)
//                die("<br>顼<br>get_value:Ρֹ椬۾Ǥid=$id");
    $value = ""; 
    for($i=0;$i<$num;$i++){
      $value .= stripslashes(trim($this->result ($result, $i, 0))) . "\n";
    }
    $this->free_result($result);
    return $value;
  }
  function get_child_value($id,$child_name){
    if($child_name == ""){
      die("<br>顼<br>get_child_value:̾Ǥid=$id child_name=$child_name");
    }
    $child_name=addslashes($child_name);
    $child_name = mb_convert_encoding($child_name,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$child_name' and type=$this->ELEMENT_TYPE order by pos";
    $result = $this->do_query($sql,"get_child_value");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_child_value:Ρֹޤϻ̾۾Ǥid=$id child_name=$child_name");
	$value="";
    for($i=0;$i<$num;$i++){
		$id = $this->result ($result, $i, 0);
    	$value .= $this->get_value($id);
	}
    $this->free_result($result);
    return $value;
  }
  function get_child_value_ns($id,$child_name,$ns){
    if($child_name == ""){
      die("<br>顼<br>get_child_value_ns:̾Ǥid=$id child_name=$child_name ns=$ns");
    }
    $child_name=addslashes($child_name);
    $ns=addslashes($ns);
    $child_name = mb_convert_encoding($child_name,"$this->i_encode","$this->p_encode");
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$child_name' and ns='$ns' and type=$this->ELEMENT_TYPE order by pos";
    $result = $this->do_query($sql,"get_child_value_ns");
    $num = $this->num_rows($result);
    if($num == 0){
      $child_name = mb_convert_encoding($child_name,"$this->p_encode","$this->i_encode");
      $ns = mb_convert_encoding($ns,"$this->p_encode","$this->i_encode");
      die("<br>顼<br>get_child_value_ns:Ρֹޤϻ̾۾Ǥid=$id child_name=$child_name ns=$ns");
    }
    $id = $this->result ($result, 0, 0);
    $value = $this->get_value($id);
    $this->free_result($result);
    return $value;
  }
  function get_comment($id){
    $sql = "select value from $this->table where id=$id and type=$this->COMMENT_TYPE";
    $result = $this->do_query($sql,"get_comment");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_comment:Ρֹ椬۾Ǥid=$id");
    $value = stripslashes($this->result ($result, 0, 0));
    $this->free_result($result);
    return $value;
  }
  function get_xml($id){
    $sql = "select value from $this->table where id=$id and type=$this->XML_TYPE";
    $result = $this->do_query($sql,"get_xml");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_xml:Ρֹ椬۾Ǥid=$id");
    $value = stripslashes($this->result ($result, 0, 0));
    $this->free_result($result);
    return $value;
  }
  function get_dtd($id){
    $sql = "select value from $this->table where id=$id and type=$this->DTD_TYPE";
    $result = $this->do_query($sql,"get_dtd");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_dtd:Ρֹ椬۾Ǥid=$id");
    $value = stripslashes($this->result ($result, 0, 0));
    $this->free_result($result);
    return $value;
  }
  function get_pi($id){
    $sql = "select name,value from $this->table where id=$id and type=$this->PI_TYPE";
    $result = $this->do_query($sql,"get_pi");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_pi:Ρֹ椬۾Ǥid=$id");
    $target = stripslashes(trim($this->result ($result, 0, 0)));
    $data = stripslashes(trim($this->result ($result, 0, 1)));
    $pi = "<?${target}\n\t${data}\n?>\n";
    $this->free_result($result);
    return $pi;
  }
  function get_ns($id){
    $sql = "select ns from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"get_ns");
    $num = $this->num_rows($result);
    if($num == 0){
      die("<br>顼<br>get_ns:Ρֹ椬۾Ǥid=$id");
    }
    $ns = stripslashes(trim($this->result ($result, 0, 0)));
    $this->free_result($result);
    return $ns;
  }
  function get_uri($ns,$id){
    if($ns == ""){
      while(1){
        $sql = "select value from $this->table where parent=$id and name='default' and type=$this->NAME_TYPE";
        $result = $this->do_query($sql,"get_uri");
        $num = $this->num_rows($result);
        if($num == 0){
          if($id == 0)
            die("<br>顼<br>get_uri:Ρֹ椫͡ॹڡ۾Ǥid=$id ns=$ns");
          $sql = "select parent from $this->table where id=$id";
          $result2 = $this->do_query($sql,"get_uri");
          $num = $this->num_rows($result2);
          if($num == 0){
            die("<br>顼<br>get_uri:Ρֹ椫͡ॹڡ۾Ǥid=$id ns=$ns");
          }else{
            $id = $this->result ($result2, 0, 0);
          }
          $this->free_result($result2);
        }else{
          break;
        }
      }
    }else{
      $sql = "select value from $this->table where name='$ns' and type=$this->NAME_TYPE";
      $result = $this->do_query($sql,"get_uri");
      $num = $this->num_rows($result);
      if($num == 0){
        die("<br>顼<br>get_uri:Ρֹ椫͡ॹڡ۾Ǥid=$id ns=$ns");
      }
    }
    $uri = stripslashes(trim($this->result ($result, 0, 0)));
    $this->free_result($result);
    return $uri;
  }
  function get_node_name($id){
    $sql = "select name from $this->table where id=$id";
    $result = $this->do_query($sql,"get_node_name");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_node_name:Ρֹ椬۾Ǥid=$id");
    $name = stripslashes($this->result ($result, 0, 0));
    $this->free_result($result);
    return $name;
  }
  function get_node_type($id){
    $sql = "select type from $this->table where id=$id";
    $result = $this->do_query($sql,"get_node_value");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_node_type:Ρֹ椬۾Ǥid=$id");
    $type = $this->result ($result, 0, 0);
    $this->free_result($result);
    return $typ;
  }
  function get_node_value($id){
    $sql = "select value from $this->table where id=$id";
    $result = $this->do_query($sql,"get_node_value");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_node_value:Ρֹ椬۾Ǥid=$id");
    $value = stripslashes($this->result ($result, 0, 0));
    $this->free_result($result);
    return $value;
  }
  function get_node_pos($id){
    $sql = "select pos from $this->table where id=$id";
    $result = $this->do_query($sql,"get_node_pos");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_node_pos:Ρֹ椬۾Ǥid=$id");
    $pos = $this->result ($result, 0, 0);
    $this->free_result($result);
    return $pos;
  }
  function get_node_parent($id){
    $sql = "select parent from $this->table where id=$id";
    $result = $this->do_query($sql,"get_node_parent");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>get_node_value:Ρֹ椬۾Ǥid=$id");
    $parent = $this->result ($result, 0, 0);
    $this->free_result($result);
    return $parent;
  }
  function get_nodes($type){
    $sql = "select id from $this->table where type=$type";
    $result = $this->do_query($sql,"get_nodes");
    $num = $this->num_rows($result);
    //        if($num == 0)
    //            die("<br>顼<br>get_nodes:ΥפΥΡɤϤޤtype=$type");
    $node_array = array();
    for($i=0;$i<$num;$i++){
      $node_array[$i] = $this->result ($result, $i, 0);
    }
    $this->free_result($result);
    return $node_array;
  }
  function get_attrib($id,$attrib_name){
    if($attrib_name == ""){
      die("<br>顼<br>get_attrib:°̾Ǥid=$id attrib_name=$attrib_name");
    }
    $attrib_name = addslashes($attrib_name);
    $attrib_name = mb_convert_encoding($attrib_name,"$this->i_encode","$this->p_encode");
    $sql = "select value from $this->table where parent=$id and name='$attrib_name' and type=$this->ATTR_TYPE order by pos";
    $result = $this->do_query($sql,"get_attrib");
    $num = $this->num_rows($result);
    $value="";
    if($num != 0){
      $value = stripslashes($this->result ($result, 0, 0));
    }
    $this->free_result($result);
    return $value;
  }
  function get_attribs($id){
    $node_array = array();
    $sql = "select name,value from $this->table where parent=$id and type=$this->ATTR_TYPE order by pos";
    $result = $this->do_query($sql,"get_attribs");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $node_array["name"][$i] = stripslashes($this->result ($result, $i, 0));
      $node_array["value"][$i] = stripslashes($this->result ($result, $i, 1));
    }
    $this->free_result($result);
    return $node_array;
  }
  function del_child($child){
    $sql = "select pos,parent,type from $this->table where id=$child for update";
    $result = $this->do_query($sql,"del_child");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>del_child:Ρֹ椬۾Ǥid=$child");
    $pos = $this->result ($result, 0, 0);
    $parent = $this->result ($result, 0, 1);
    $type = $this->result ($result, 0, 2);
    $this->free_result($result);
    if($type == $this->ATTR_TYPE){
      $sql = "select * from $this->table where parent=$parent and type=$type and pos>$pos for update";
      $result = $this->do_query($sql,"del_child");
      $sql = "update $this->table set pos=pos-1 where parent=$parent and type=$type and pos>$pos";
      $this->do_query($sql,"del_child");
    }else{
      $sql = "select * from $this->table where parent=$parent and type!=$this->ATTR_TYPE and pos>$pos for update";
      $result = $this->do_query($sql,"del_child");
      $sql = "update $this->table set pos=pos-1 where parent=$parent and type!=$this->ATTR_TYPE and pos>$pos";
      $this->do_query($sql,"del_child");
    }
    $sql = "update $this->table set parent=null , pos=1 where id=$child";
    $this->do_query($sql,"del_child");
    $this->free_result($result);
    return $child;
  }
  function del_child_element($id,$child_name){
    if($child_name == ""){
      die("<br>顼<br>del_child_element:̾Ǥid=$id child_name=$child_name");
    }
    $child_name = addslashes($child_name);
    $child_name = mb_convert_encoding($child_name,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$child_name' and type=$this->ELEMENT_TYPE order by pos";
    $result = $this->do_query($sql,"del_child_element");
    $num = $this->num_rows($result);
    if($num == 0){
      $child_name = mb_convert_encoding($child_name,"$this->i_encode","$this->p_encode");
      die("<br>顼<br>del_child_element:Ρֹޤϻ̾۾Ǥid=$id child_name=$child_name");
    }
    $child = $this->result ($result, 0, 0);
    $this->del_child($child);
    $this->free_result($result);
    return $child;
  }
  function del_child_element_ns($id,$child_name,$ns){
    if($child_name == ""){
      die("<br>顼<br>del_child_element_ns:̾Ǥid=$id child_name=$child_name ns=$ns");
    }
    $child_name = addslashes($child_name);
    $ns = addslashes($ns);
    $child_name = mb_convert_encoding($child_name,"$this->i_encode","$this->p_encode");
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$child_name' and ns='$ns' and type=$this->ELEMENT_TYPE order by pos";
    $result = $this->do_query($sql,"del_child_element_ns");
    $num = $this->num_rows($result);
    if($num == 0){
      $child_name = mb_convert_encoding($child_name,"$this->i_encode","$this->p_encode");
      die("<br>顼<br>del_child_element_ns:Ρֹޤϻ̾۾Ǥid=$id child_name=$child_name ns=$ns");
    }
    $child = $this->result ($result, 0, 0);
    $this->del_child($child);
    $this->free_result($result);
    return $child;
  }
  function del_attrib($id,$attrib){
    if($attrib == ""){
      die("<br>顼<br>get_elements:°̾Ǥid=$id attrib_name=$attrib");
    }
    $attrib = addslashes($attrib);
    $attrib = mb_convert_encoding($attrib,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$attrib' and type=$this->ATTR_TYPE order by pos";
    $result = $this->do_query($sql,"del_attrib");
    $num = $this->num_rows($result);
    if($num == 0){
      $attrib= mb_convert_encoding($attrib,"$this->p_encode","$this->i_encode");
      die("<br>顼<br>del_attrib:Ρֹޤ°̾۾Ǥid=$id attrib=$attrib");
    }
    $child = $this->result ($result, 0, 0);
    $this->del_child($child);
    $this->free_result($result);
    return $child;
  }
  function del_text($id){
    $sql = "select id from $this->table where id=$id and type=$this->TEXT_TYPE for update";
    $result = $this->do_query($sql,"del_text");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>del_text:Ρֹ椬۾Ǥid=$id ");
    $this->del_child($id);
    $this->free_result($result);
    return $id;
  }
  function del_comment($id){
    $sql = "select id from $this->table where id=$id and type=$this->COMMENT_TYPE for update";
    $result = $this->do_query($sql,"del_comment");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>del_comment:Ρֹ椬۾Ǥid=$id ");
    $this->del_child($id);
    $this->free_result($result);
    return $id;
  }
  function del_element_value($id){
    $sql = "select id from $this->table where parent=$id and type=$this->TEXT_TYPE  order by pos for update";
    $result = $this->do_query($sql,"del_element_value");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>del_element_value:Ρֹ椬۾ޤϥƥȤޤid=$id ");
    
    for($i=0;$i<$num;$i++){
      $text = $this->result ($result, $i, 0);
      $sql = "delete from $this->table where id=$text";
      $this->do_query($sql,"del_element_value");
    }
    $this->free_result($result);
  }
  function del_node($id,$flg){
    if($flg == 1){
      $sql = "select id from $this->table where parent=$id order by pos";
      $result = $this->do_query($sql,"del_node");
      $num = $this->num_rows($result);
      for($i=0;$i<$num;$i++){
        $child = $this->result ($result, $i, 0);
        $this->del_node($child,1);
      }
      $this->free_result($result);
    }
    $sql = "select id from $this->table where id=$id for update";
    $result = $this->do_query($sql,"del_node");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>del_node:Ρֹ椬۾Ǥid=$id");
    $sql = "delete from $this->table where id=$id";
    $this->do_query($sql,"del_node");
    $this->free_result($result);
  }
  function add_child($id,$child){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"add_child");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>add_child:Ρֹ椬۾Ǥid=$id ");
    $this->free_result($result);
    $sql = "select id from $this->table where id=$child  and type=$this->ELEMENT_TYPE for update";
    $result = $this->do_query($sql,"add_child");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>add_child:Ρֹ椬۾Ǥchild=$child ");
    $sql = "select pos from $this->table where parent=$id and type!=$this->ATTR_TYPE order by pos DESC for update";
    $result2 = $this->do_query($sql,"add_child");
    $num = $this->num_rows($result2);    
    if($num == 0){
      $pos = 1;
    }else{
      $pos = $this->result($result2, 0, 0) + 1;
    }
    $sql = "update $this->table set pos=$pos , parent=$id where id=$child";
    $this->do_query($sql,"add_child");
    $this->free_result($result);
    $this->free_result($result2);
  }        
  function add_text($id,$text){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"add_text");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>add_text:Ρֹ椬۾Ǥid=$id ");
    $this->free_result($result);
    $sql = "select id from $this->table where id=$text  and type=$this->TEXT_TYPE for update";
    $result = $this->do_query($sql,"add_text");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>add_text:ƥȥΡֹ椬۾Ǥtext=$text ");
    $sql = "select pos from $this->table where parent=$id and type!=$this->ATTR_TYPE order by pos DESC for update";
    $result2 = $this->do_query($sql,"add_text");
    $num = $this->num_rows($result2);    
    if($num == 0){
      $pos = 1;
    }else{
      $pos = $this->result($resul2t, 0, 0) + 1;
    }
    $sql = "update $this->table set pos=$pos , parent=$id where id=$text";
    $this->do_query($sql,"add_text");
    $this->free_result($result);
    $this->free_result($result2);
  }        
  function add_attrib($id,$attrib){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"add_attrib");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>add_attrib:Ρֹ椬۾Ǥid=$id ");
    $this->free_result($result);
    $sql = "select id from $this->table where id=$attrib  and type=$this->ATTR_TYPE for update";
    $result = $this->do_query($sql,"add_attrib");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>add_attrib:°Ρֹ椬۾Ǥtext=$attrib ");
    $sql = "select pos from $this->table where parent=$id and type=$this->ATTR_TYPE order by pos DESC for update";
    $result2 = $this->do_query($sql,"add_attrib");
    $num = $this->num_rows($result2);    
    if($num == 0){
      $pos = 1;
    }else{
      $pos = $this->result($result2, 0, 0) + 1;
    }
    $sql = "update $this->table set pos=$pos , parent=$id where id=$attrib";
    $this->do_query($sql,"add_attrib");
    $this->free_result($result);
    $this->free_result($result2);
    
    $parent = 0-$attrib;
    $sql = "select id from $this->table where parent='$parent' and type='$this->NAME_TYPE' for update";
    $result = $this->do_query($sql,"add_attrib");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $id2 = $this->result($result, $i, 0);
      $sql = "update $this->table set parent='$id' where id='$id2'";
      $this->do_query($sql,"add_attrib");
    }
    $this->free_result($result);
  }        
  function add_comment($id,$comment){
    if($id != 0){
      $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
      $result = $this->do_query($sql,"add_comment");
      $num = $this->num_rows($result);
      if($num == 0)
        die("<br>顼<br>add_comment:Ρֹ椬۾Ǥid=$id ");
      $this->free_result($result);
    }
    $sql = "select id from $this->table where id=$comment and type=$this->COMMENT_TYPE for update";
    $result = $this->do_query($sql,"add_comment");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>add_comment:ȥΡֹ椬۾Ǥcomment=$comment ");
    $sql = "select pos from $this->table where parent=$id and type!=$this->ATTR_TYPE order by pos DESC for update";
    $result2 = $this->do_query($sql,"add_comment");
    $num = $this->num_rows($result2);    
    if($num == 0){
      $pos = 1;
    }else{
      $pos = $this->result($result2, 0, 0) + 1;
    }
    $sql = "update $this->table set pos=$pos , parent=$id where id=$comment";
    $this->do_query($sql,"add_comment");
    $this->free_result($result);
    $this->free_result($result2);
  }        
  function insert_child($id,$child,$ref){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"insert_child");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_child:Ρֹ椬۾Ǥid=$id ");
    $this->free_result($result);
    $sql = "select id from $this->table where id=$child  and type=$this->ELEMENT_TYPE for update";
    $result = $this->do_query($sql,"insert_child");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_child:ҥΡֹ椬۾Ǥchild=$child ");
    $sql = "select pos from $this->table where id=$ref for update";
    $result2 = $this->do_query($sql,"insert_child");
    $num = $this->num_rows($result2);
    if($num == 0)
      die("<br>顼<br>insert_child:ե󥹥Ρֹ椬۾Ǥref=$ref ");
    $pos = $this->result($result2,0,0);
    $sql = "update $this->table set pos=pos+1 where parent=$id and pos>=$pos and type!=$this->ATTR_TYPE";
    $this->do_query($sql,"insert_child");
    $sql = "update $this->table set pos=$pos , parent=$id where id=$child";
    $this->do_query($sql,"insert_child");
    $this->free_result($result);
    $this->free_result($result2);
  }        
  function insert_text($id,$child,$ref){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"insert_text");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_text:Ρֹ椬۾Ǥid=$id ");
    $this->free_result($result);
    $sql = "select id from $this->table where id=$child  and type=$this->TEXT_TYPE for update";
    $result = $this->do_query($sql,"insert_text");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_text:ƥȥΡֹ椬۾Ǥchild=$child ");
    $sql = "select pos from $this->table where id=$ref for update";
    $result2 = $this->do_query($sql,"insert_text");
    $num = $this->num_rows($result2);
    if($num == 0)
      die("<br>顼<br>insert_text:ե󥹥Ρֹ椬۾Ǥref=$ref ");
    $pos = $this->result($result2,0,0);
    $sql = "update $this->table set pos=pos+1 where parent=$id and pos>=$pos and type!=$this->ATTR_TYPE";
    $this->do_query($sql,"insert_text");
    $sql = "update $this->table set pos=$pos , parent=$id where id=$child";
    $this->do_query($sql,"insert_text");
    $this->free_result($result);
    $this->free_result($result2);
  }        
  function insert_attrib($id,$child,$ref){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"insert_attrib");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_attrib:Ρֹ椬۾Ǥid=$id ");
    $this->free_result($result);
    $sql = "select id from $this->table where id=$child  and type=$this->ATTR_TYPE for update";
    $result = $this->do_query($sql,"insert_attrib");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_attrib:°Ρֹ椬۾Ǥchild=$child ");
    $sql = "select pos from $this->table where id=$ref  and type=$this->ATTR_TYPE for update";
    $result2 = $this->do_query($sql,"insert_attrib");
    $num = $this->num_rows($result2);
    if($num == 0)
      die("<br>顼<br>insert_attrib:ե󥹥Ρֹ椬۾Ǥref=$ref ");
    $pos = $this->result($result2,0,0);
    $sql = "update $this->table set pos=pos+1 where parent=$id and pos>=$pos and type=$this->ATTR_TYPE";
    $this->do_query($sql,"insert_attrib");
    $sql = "update $this->table set pos=$pos , parent=$id where id=$child";
    $this->do_query($sql,"insert_attrib");
    $this->free_result($result);
    $this->free_result($result2);
    
    $parent = 0-$child;
    $sql = "select id from $this->table where parent='$parent' and type='$this->NAME_TYPE' for update";
    $result = $this->do_query($sql,"add_attrib");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $id2 = $this->result($result, $i, 0);
      $sql = "update $this->table set parent='$id' where id='$id2'";
      $this->do_query($sql,"insert_attrib");
    }
    $this->free_result($result);
  }        
  function insert_comment($id,$child,$ref){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE";
    $result = $this->do_query($sql,"insert_comment");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_comment:Ρֹ椬۾Ǥid=$id ");
    $this->free_result($result);
    $sql = "select id from $this->table where id=$child  and type=$this->COMMENT_TYPE for update";
    $result = $this->do_query($sql,"insert_comment");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>insert_comment:°Ρֹ椬۾Ǥchild=$child ");
    $sql = "select pos from $this->table where id=$ref for update";
    $result2 = $this->do_query($sql,"insert_comment");
    $num = $this->num_rows($result2);
    if($num == 0)
      die("<br>顼<br>insert_comment:ե󥹥Ρֹ椬۾Ǥref=$ref ");
    $pos = $this->result($result2,0,0);
    $sql = "update $this->table set pos=pos+1 where parent=$id and pos>=$pos and type!=$this->ATTR_TYPE";
    $this->do_query($sql,"insert_comment");
    $sql = "update $this->table set pos=$pos , parent=$id where id=$child";
    $this->do_query($sql,"insert_comment");
    $this->free_result($result);
    $this->free_result($result2);
  }        
  function make_element($name){
    if($name == ""){
      die("<br>顼<br>make_element:̾Ǥid=$id name=$name");
    }
    $sql = "select id from $this->table order by id desc for update";
    $result = $this->do_query($sql,"make_element");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $name = addslashes($name);
    $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
    $ns = "";
    $sql = "insert into $this->table (id,type,name,pos,ns) values($id,$this->ELEMENT_TYPE,'$name',1,'$ns')";
    $this->do_query($sql,"make_element");
    $this->free_result($result);
    return $id;
  }
  function make_element_ns($name,$ns){
    if($name == ""){
      die("<br>顼<br>make_element_ns:̾Ǥid=$id name=$name ns=$ns");
    }
    $sql = "select id from $this->table order by id desc for update";
    $result = $this->do_query($sql,"make_element_ns");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $name = addslashes($name);
    $ns = addslashes($ns);
    $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "insert into $this->table (id,type,name,pos,ns) values($id,$this->ELEMENT_TYPE,'$name',1,'$ns')";
    $this->do_query($sql,"make_element_ns");
    $this->free_result($result);
    return $id;
  }
  function make_text($value){
    if($value == ""){
      die("<br>顼<br>make_text:ƥȤͤǤvalue=$value");
    }
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_text");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $value = addslashes($value);
    $value = mb_convert_encoding($value,"$this->i_encode","$this->p_encode");
    $sql = "insert into $this->table (id,type,value,pos) values($id,$this->TEXT_TYPE,'$value',1)";
    $this->do_query($sql,"make_text");
    $this->free_result($result);
    return $id;
  }
  function make_attrib($attrib_name,$attrib_value){
    if($attrib_name == ""){
      die("<br>顼<br>make_attrib:°̾Ǥattrib_name=$attrib_name attrib_value=$attrib_value");
    }
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_attrib");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $attrib_name = addslashes($attrib_name);
    $attrib_value = addslashes($attrib_value);
    $attrib_name = mb_convert_encoding($attrib_name,"$this->i_encode","$this->p_encode");
    $attrib_value = mb_convert_encoding($attrib_value,"$this->i_encode","$this->p_encode");
    $sql = "insert into $this->table (id,type,name,value,pos) values($id,$this->ATTR_TYPE,'$attrib_name','$attrib_value',1)";
    $this->do_query($sql,"make_attrib");
    $this->free_result($result);
    
    $sql = "select pos from $this->table where type=$this->NAME_TYPE and name='default' order by pos DESC";
    $result = $this->do_query($sql,"make_attrib");
    $num = $this->num_rows($result);    
    if($num == 0){
      $nsd_index = 0;
    }else{
      $nsd_index = $this->result ($result, 0, 0) + 1;
    }
    $parent = 0-$id;
    //͡ॹڡν
    if(preg_match("/xmlns:/i",$attrib_name)){
      $attrib_name = preg_replace("/xmlns:/i","",$attrib_name);
      $id2 = $id+1;
      $sql = "insert into $this->table (id,type,name,value,parent,pos) values($id2,$this->NAME_TYPE,'$attrib_name','$attrib_value',$parent,0)";
      $this->do_query($sql,"make_attrib");
    }
    if(preg_match("/xmlns/i",$attrib_name)){
      $id2 = $id+1;
      $sql = "insert into $this->table (id,type,name,value,parent,pos) values($id2,$this->NAME_TYPE,'default','$attrib_value',$parent,$nsd_index)";
      $this->do_query($sql,"make_attrib");
    }
    $this->free_result($result);
    return $id;
  }
  function make_comment($comment){
    if($comment == ""){
      die("<br>顼<br>make_comment:ȤǤcomment=$comment");
    }
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_comment");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $comment = addslashes($comment);
    $comment = mb_convert_encoding($comment,"$this->i_encode","$this->p_encode");
    $sql = "insert into $this->table (id,type,value,pos) values($id,$this->COMMENT_TYPE,'$comment',1)";
    $this->do_query($sql,"make_comment");
    $this->free_result($result);
    return $id;
  }
  function make_doc_root($node_name){
    if($node_name == ""){
      die("<br>顼<br>make_doc_root:̾Ǥnode_name=$node_name");
    }
    $sql = "select id from $this->table where type=$this->ELEMENT_TYPE and parent=0";
    $result = $this->do_query($sql,"make_doc_root");
    $num = $this->num_rows($result);
    if($num != 0)
      die("<br>顼<br>make_doc_root: ɥȥ롼ȤʣǤޤ");
    $this->free_result($result);
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_doc_root");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $node_name = addslashes($node_name);
    $node_name = mb_convert_encoding($node_name,"$this->i_encode","$this->p_encode");
    $ns = "";
    $sql = "insert into $this->table (id,type,name,parent,pos,ns) values($id,$this->ELEMENT_TYPE,'$node_name',0,1,'$ns')";
    $this->do_query($sql,"make_doc_root");
    $this->free_result($result);
    return $id;
  }
  function make_doc_root_ns($node_name,$ns){
    if($node_name == ""){
      die("<br>顼<br>make_doc_root_ns:̾Ǥnode_name=$node_name ns=$ns");
    }
    $sql = "select id from $this->table where type=$this->ELEMENT_TYPE and parent=0";
    $result = $this->do_query($sql,"make_doc_root");
    $num = $this->num_rows($result);
    if($num != 0)
      die("<br>顼<br>make_doc_root: ɥȥ롼ȤʣǤޤ");
    $this->free_result($result);
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_doc_root_ns");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $node_name = addslashes($node_name);
    $ns = addslashes($ns);
    $node_name = mb_convert_encoding($node_name,"$this->i_encode","$this->p_encode");
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
   $sql = "insert into $this->table (id,type,name,parent,pos,ns) values($id,$this->ELEMENT_TYPE,'$node_name',0,1,'$ns')";
    $this->do_query($sql,"make_doc_root_ns");
    $this->free_result($result);
    return $id;
  }
  function make_dtd($dtd){
    if($dtd == ""){
      die("<br>顼<br>make_dtd:DTDǤdtd=$dtd");
    }
    $sql = "select id from $this->table where type=$this->DTD_TYPE and parent=0";
    $result = $this->do_query($sql,"make_dtd");
    $num = $this->num_rows($result);
    if($num != 0)
      die("<br>顼<br>make_dtd: DTDʣǤޤ");
    $this->free_result($result);
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_dtd");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $dtd = addslashes($dtd);
    $dtd = mb_convert_encoding($dtd,"$this->i_encode","$this->p_encode");
    $sql = "insert into $this->table (id,type,value,parent,pos) values($id,$this->DTD_TYPE,'$dtd',0,1)";
    $this->do_query($sql,"make_dtd");
    $this->free_result($result);
    return $id;
  }
  function make_xml($xml){
    if($xml == ""){
      die("<br>顼<br>make_xml:XMLǤxml=$xml");
    }
    $sql = "select id from $this->table where type=$this->XML_TYPE and parent=0";
    $result = $this->do_query($sql,"make_xml");
    $num = $this->num_rows($result);
    if($num != 0)
      die("<br>顼<br>make_xml: XMLʣǤޤ");
    $this->free_result($result);
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_xml");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $xml = addslashes($xml);
    $xml = mb_convert_encoding($xml,"$this->i_encode","$this->p_encode");
    $sql = "insert into $this->table (id,type,value,parent,pos) values($id,$this->XML_TYPE,'$xml',0,1)";
    $this->do_query($sql,"make_xml");
    $this->free_result($result);
    return $id;
  }
  function make_pi($target,$data){
    if($target == ""){
      die("<br>顼<br>make_pi:targetǤtarget=$target data=$data");
    }
    if($data == ""){
      die("<br>顼<br>make_pi:dataǤtarget=$target data=$data");
    }
    $sql = "select max(pos) from $this->table where type=$this->PI_TYPE and parent=0";
    $result = $this->do_query($sql,"make_pi");
    $pos = $this->result($result,0,0);
    $this->free_result($result);
    if($pos == "")
      $pos = 1;
    else
      $pos++;
    $sql = "select id from $this->table order by id DESC for update";
    $result = $this->do_query($sql,"make_pi");
    $num = $this->num_rows($result);    
    if($num == 0){
      $id = 1;
    }else{
      $id = $this->result ($result, 0, 0) + 1;
    }
    $target = addslashes($target);
    $data = addslashes($data);
    $target = mb_convert_encoding($target,"$this->i_encode","$this->p_encode");
    $data = mb_convert_encoding($data,"$this->i_encode","$this->p_encode");
    $sql = "insert into $this->table (id,type,name,value,parent,pos) values($id,$this->PI_TYPE,'$target','$data',0,$pos)";
    $this->do_query($sql,"make_pi");
    $this->free_result($result);
    return $id;
  }
  function set_value($id,$value){
    if($value == ""){
      die("<br>顼<br>set_value:ͤǤvalue=$value");
    }
    $sql = "select id from $this->table where parent=$id and type=$this->TEXT_TYPE order by pos for update";
    $result = $this->do_query($sql,"set_value");
    $num = $this->num_rows($result);
    if($num == 0){
      $text = $this->make_text($value);
      $this->add_text($id,$text);
    }else{
      $value = addslashes($value);
      $value = mb_convert_encoding($value,"$this->i_encode","$this->p_encode");
      $id2 = $this->result ($result, 0, 0);
      $sql = "update $this->table set value='$value' where id=$id2";
      $this->do_query($sql,"set_value");
      for($i=1;$i<$num;$i++){
        $id2 = $this->result ($result, $i, 0);
        $this->del_node($id2,0);
      }
      $this->free_result($result);
      $sql = "select id from $this->table where parent=$id and type!=$this->ATTR_TYPE order by pos for update";
      $result = $this->do_query($sql,"set_value");
      $num = $this->num_rows($result);
      for($i=1;$i<=$num;$i++){
        $id2 = $this->result($result,$i,0);
        $sql = "update $this->table set pos=$i where id=$id2";
        $this->do_query($sql,"set_value");
      }
    }
    $this->free_result($result);
  }
  function set_text($id,$text){
    if($text == ""){
      die("<br>顼<br>set_text:ͤǤtext=$text");
    }
    $sql = "select id from $this->table where id=$id and type=$this->TEXT_TYPE for update";
    $result = $this->do_query($sql,"set_text");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>set_text:Ρֹ椬۾Ǥid=$id");
    $value = addslashes($text);
    $value = mb_convert_encoding($value,"$this->i_encode","$this->p_encode");
    $sql = "update $this->table set value='$value' where id=$id";
    $this->do_query($sql,"set_text");
    $this->free_result($result);
  }
  function set_attrib($id,$attrib_name,$attrib_value){
    if($attrib_name == ""){
      die("<br>顼<br>set_attrib:°̾Ǥid=$id attrib_name=$attrib_name attrib_value=$attrib_value");
    }
    $attrib_name2 = addslashes($attrib_name);
    $attrib_name2 = mb_convert_encoding($attrib_name2,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where parent=$id and name='$attrib_name2' and type=$this->ATTR_TYPE for update";
    $result = $this->do_query($sql,"set_attrib");
    $num = $this->num_rows($result);
    if($num == 0){
      $attrib = $this->make_attrib($attrib_name,$attrib_value);
      $this->add_attrib($id,$attrib);
    }else{
      $id = $this->result ($result, 0, 0);
      $value = addslashes($attrib_value);
      $value = mb_convert_encoding($value,"$this->i_encode","$this->p_encode");
      $sql = "update $this->table set value=$value where id=$id";
      $this->do_query($sql,"set_attrib");
    }
    $this->free_result($result);
  }
  function set_node_name($id,$name){
    if($name == ""){
      die("<br>顼<br>set_node_name:̾Ǥid=$id name=$name");
    }
    $sql = "select id from $this->table where id=$id for update ";
    $result = $this->do_query($sql,"set_node_name");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>set_node_name:Ρֹ椬۾Ǥid=$id");
    $name = addslashes($name);
    $name = mb_convert_encoding($name,"$this->i_encode","$this->p_encode");
    $sql = "update $this->table set name='$name' where id=$id";
    $this->do_query($sql,"set_node_name");
    $this->free_result($result);
  }
  
  function set_ns($id,$ns){
    $sql = "select id from $this->table where id=$id and type=$this->ELEMENT_TYPE for update ";
    $result = $this->do_query($sql,"set_ns");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>set_ns:Ρֹ椬۾Ǥid=$id");
    $ns = addslashes($ns);
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "update $this->table set ns='$ns' where id=$id";
    $this->do_query($sql,"set_ns");
    $this->free_result($result);
  }
  function set_uri($ns,$uri){
    if($uri ==""){
      die("<br>顼<br>set_uri:URIǤns=$ns URI=$uri");
    }
    if($ns == ""){
      die("<br>顼<br>set_uri:͡ॹڡǤns=$ns URI=$uri");
    }
    $ns = addslashes($ns);
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where name='$ns' and type=$this->NAME_TYPE for update ";
    $result = $this->do_query($sql,"set_ns");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>set_uri:͡ॹڡ۾Ǥns=$ns");
    $uri = addslashes($uri);
    $uri = mb_convert_encoding($uri,"$this->i_encode","$this->p_encode");
    $sql = "update $this->table set value='$uri' where name='$ns' and type=$this->NAME_TYPE";
    $this->do_query($sql,"set_uri");
    $this->free_result($result);
    $ns = mb_convert_encoding($ns,"$this->p_encode","$this->i_encode");
    $ns = "xmlns:" . $ns;
    $ns = addslashes($ns);
    $ns = mb_convert_encoding($ns,"$this->i_encode","$this->p_encode");
    $sql = "select id from $this->table where name='$ns' and type=$this->ATTR_TYPE for update ";
    $result = $this->do_query($sql,"set_ns");
    $num = $this->num_rows($result);
    if($num == 0)
      die("<br>顼<br>set_uri:°ޤattr_name=$ns");
    $sql = "update $this->table set value='$uri' where name='$ns' and type=$this->ATTR_TYPE";
    $this->do_query($sql,"set_uri");
    $this->free_result($result);
  }
  
  function write_attribs($id){
    $node_array = $this->get_attribs($id);
    if(@$node_array["name"][0] != ""){
      $num = count($node_array["name"]);
      for($i=0;$i<$num;$i++){
        $name = $node_array["name"][$i];
        $value = $node_array["value"][$i];
		$this->text .= " $name=\"$value\"";
      }
    }
  }
  function write_comment($id){
    $sql = "select value from $this->table where id=$id and type=$this->COMMENT_TYPE";
    $result = $this->do_query($sql,"write_comment");
    $value = $this->result($result,0,0);
    $this->free_result($result);
    $value = trim($value);
    $this->text .= "$value\n";
  }
  function write_node($id,$level){
    $sql = "select name,type,ns from $this->table where id=$id";
    $result = $this->do_query($sql,"write_node");
    $name = $this->result($result,0,0);
    $type = $this->result($result,0,1);
    $ns = $this->result($result,0,2);
    $this->free_result($result);
    if($ns != "")
      $name = $ns .":" .$name;
    for($i=0;$i<$level;$i++){
      $this->text .= "\t";
    }
    if($type == $this->COMMENT_TYPE){
      $this->write_comment($id);
    }else{
      $sql = "select id from $this->table where parent=$id and (type=$this->ELEMENT_TYPE or type=$this->COMMENT_TYPE) order by pos";
      $result = $this->do_query($sql,"write_node");
      $num = $this->num_rows($result);
      $sql = "select value from $this->table where parent=$id and type=$this->TEXT_TYPE order by pos";
      $result2 = $this->do_query($sql,"write_node");
      $num2 = $this->num_rows($result2);
      $name = trim($name);
      $value = "";
      for($i=0;$i<$num2;$i++){
        $value .= trim($this->result ($result2, $i, 0)) . "\n";
      }
      $text_array = preg_split("/\n/",$value);
      $this->text .= "<$name";
      $this->write_attribs($id);
      if($num == 0){
        if(@$text_array[0] == ""){
	  $this->text .= "/>\n";
        }else if(@$text_array[1] == ""){
          $value = $text_array[0];
	  $this->text .= ">$value</$name>\n";
        }else{
          $num2 = count($text_array);
          $value = ""; 
          for($i=0;$i<$num2;$i++){
            if($text_array[$i] != ""){
              for($j=0;$j<=$level;$j++){
                $value .= "\t";
              }
              $value .= $text_array[$i] . "\n";
            }
          }
	  $this->text .= ">\n";
	  $this->text .= "$value";
	  for($i=0;$i<$level;$i++){
	    $this->text .= "\t";
	  }
	  $this->text .= "</$name>\n";
        }
      }else{
		$this->text .= ">\n";
        $sql = "select id,type,value from $this->table where parent=$id and (type=$this->ELEMENT_TYPE or type=$this->COMMENT_TYPE or type=$this->TEXT_TYPE) order by pos";
        $result = $this->do_query($sql,"write_node");
        $num = $this->num_rows($result);
        for($i=0;$i<$num;$i++){
          $type = $this->result($result,$i,1);
          if(($type == $this->ELEMENT_TYPE)||($type == $this->COMMENT_TYPE)){
            $child = $this->result($result,$i,0);
            $this->write_node($child,$level+1);
          }else{
            $value = trim($this->result ($result, $i, 2));
            $text_array = preg_split("/\n/",$value);
            $num2 = count($text_array);
            $value = ""; 
            for($j=0;$j<$num2;$j++){
              if($text_array[$j] != ""){
                for($k=0;$k<=$level;$k++){
                  $value .= "\t";
                }
                $value .= $text_array[$j] . "\n";
              }
            }
	    $this->text .= "$value";
          }
        }
        $this->free_result($result);
	for($i=0;$i<$level;$i++){
	  $this->text .= "\t";
	}
	$this->text .= "</$name>\n";
      }
    }
  }
  function write_document($fp,$flg){
    $sql = "select value from $this->table where type=$this->XML_TYPE order by pos";
    $result = $this->do_query($sql,"write_document");
    $this->xml_block = trim($this->result($result,0,0));
    if($this->xml_block == ""){
      $this->text .="<?xml version=\"1.0\" encoding=\"EUC-JP\" ?>\n";
    }else{
      $this->text .= "$this->xml_block\n";
      //encodeμ
      $pos = strpos($this->xml_block , "encoding");
      if($pos == 0){
	$this->p_encode = "ISO-8859-1";
      }else{
	$this->p_encode = substr($this->xml_block,$pos+10);
	$this->p_encode = str_replace("'","\"",$this->p_encode);
	$pos = strpos($this->p_encode , "\"");
	$this->p_encode = substr($this->p_encode,0,$pos);
	if(strtoupper($this->p_encode)=="SHIFT_JIS"){
	  $this->p_encode = "SJIS";
	}
      }
    }

    $this->free_result($result);
    if($flg == 1){
      $sql = "select value from $this->table where type=$this->DTD_TYPE order by pos";
      $result = $this->do_query($sql,"write_document");
      $num = $this->num_rows($result);
      $dtd_block = "";
      for($i=0;$i<$num;$i++){
        $dtd_block .= trim($this->result($result,$i,0)) . "\n";
      }
      $this->free_result($result);
      $sql = "select name,value from $this->table where type=$this->PI_TYPE order by pos";
      $result = $this->do_query($sql,"write_document");
      $num = $this->num_rows($result);
      $pi_block = "";
      for($i=0;$i<$num;$i++){
        $target = trim($this->result($result,$i,0));
        $data = trim($this->result($result,$i,1));
        $pi_block .= "<?${target}\n\t${data}\n?>\n";
      }
      $this->free_result($result);
      $this->text .= "$dtd_block";
      $this->text .= "$pi_block";
    }
    $sql = "select value from $this->table where type=$this->COMMENT_TYPE and parent=0 order by pos";
    $result = $this->do_query($sql,"write_document");
    $num = $this->num_rows($result);
    $comment_block = "";
    for($i=0;$i<$num;$i++){
      $comment_block .= trim($this->result($result,$i,0)) . "\n";
    }
    $this->free_result($result);
    $this->text .= "$comment_block";
    $id = $this->get_doc_root();
    $this->write_node($id,0);
    if($fp == ""){
      return $this->text;
    }else{
      fwrite($fp,$this->text);
    }
  }
  function press(){
    $sql = "select id from $this->table where type=$this->ELEMENT_TYPE for update";
    $result = $this->do_query($sql,"press");
    $num = $this->num_rows($result);
    for($i=0;$i<$num;$i++){
      $id = $this->result($result,$i,0);
      $sql = "select id,value from $this->table where parent=$id and type=$this->TEXT_TYPE";
      $result2 = $this->do_query($sql,"press");
      $num2 = $this->num_rows($result2);
      $text = "";
      for($j=0;$j<$num2;$j++){
        $text_id = $this->result($result2,$j,0);
        $text .= trim($this->result($result2,$j,1)) ."\n";
      }
      if($num2 != 0){
        $text = addslashes(trim($text));
        $text = mb_convert_encoding($text,"$this->i_encode","$this->p_encode");
        $sql = "update $this->table set value='$text' where id=$id";
        $this->do_query($sql,"press");
      }
    }
    $sql = "delete from $this->table where type=$this->TEXT_TYPE";
    $this->do_query($sql,"press");
    $this->free_result($result);
  }
}


?>
